package br.sg3.connector3.servlet;

import java.io.Serializable;
import java.util.Properties;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.DeliveryMode;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageConsumer;
import javax.jms.MessageProducer;
import javax.jms.ObjectMessage;
import javax.jms.Queue;
import javax.jms.Session;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
@SuppressWarnings("unused")

public final class SendMessage {
	
	public SendMessage() {
		super();
	}

	public final void enviar(Serializable msg) throws Exception {
		String destinationName = "queue/testConnector";
		Context ic = null;
		ConnectionFactory cf = null;
		Connection connection =  null;

		try { 
			ic = getInitialContext();
			cf = (ConnectionFactory)ic.lookup("/ConnectionFactory");
			Queue queue = (Queue)ic.lookup(destinationName);
			connection = cf.createConnection();
			Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
			MessageProducer publisher = session.createProducer(queue);
			MessageConsumer subscriber = session.createConsumer(queue);
			connection.start();
			ObjectMessage message = session.createObjectMessage(msg);
			publisher.send(message, DeliveryMode.PERSISTENT, Message.DEFAULT_PRIORITY, 1800000);
			System.out.println("[Producer] Mensagem enviada!");
		}
		finally	{         
			if(ic != null) {
				try	{
					ic.close();
				}
				catch(Exception e) {
					throw e;
				}
			}
			closeConnection(connection);
		}
	}
	
	private void closeConnection(Connection con) {      
		try {
			if (con != null)
				con.close();
		} catch(JMSException jmse){
			System.out.println("Não foi possivel encerrar a conexão " + con +". Exception: " + jmse);
		}
	}
	
	public static Context getInitialContext() throws NamingException {
		Properties p = new Properties();
		p.put(Context.INITIAL_CONTEXT_FACTORY, "org.jnp.interfaces.NamingContextFactory");
		p.put(Context.URL_PKG_PREFIXES, " org.jboss.naming:org.jnp.interfaces");
		p.put(Context.PROVIDER_URL, "jnp://192.168.8.32:1099");
		return new InitialContext(p);
	}  
	
}
